#include <iostream>

using namespace std;

int main()
{
    long long int n, q, l, r;
    cin>> n>> q;
    int a[n + 1];
    for(int i = 0; i < n; i ++)
        cin>>a[i];
    int s[q + 1];
    for(int i = 0; i < q; i ++)
    {
        cin>> l>> r;
        s[i] = a[l - 1] & a[l];
        if(s[i] == 0)
            goto f;
        for(int j = l + 1; j < r; j ++)
        {
            s[i] &= a[j];
            if(s[i] == 0)
                break;
        }
        f:;
    }
    for(int i = 0; i < q; i ++)
        cout<< s[i]<< endl;
    return 0;
}
/*
5 4
1 5 4 3 2
1 3
4 5
2 5
2 3
*/